MODULE LinkOptions;
(* -------------------------------------------------------------------------  
   Allows access to the configuration options that are set at link time. 
 
   Target: STM Cortex-M microcontrollers
   
   (c) 2016 CFB Software   
   http://www.astrobe.com  
   
   ------------------------------------------------------------------------- *)

IMPORT SYSTEM;

VAR

  OptionsStart: INTEGER;
  
  (* Startup parameters *)
  Fosc*: INTEGER;
  Target*: INTEGER;
  HeapStart*: INTEGER;
  HeapLimit*: INTEGER;
  StackStart*: INTEGER;
  ResourceStart*: INTEGER;
  DataStart*: INTEGER;
  DataEnd*: INTEGER;
  cs, CodeStart*: INTEGER;
  CodeEnd*: INTEGER;
  

PROCEDURE* CodeStartAddress;
END CodeStartAddress;
  
BEGIN
  cs := SYSTEM.ADR(CodeStartAddress) - 244H;
  OptionsStart := cs + 200H;
  SYSTEM.GET(OptionsStart, Target);
  SYSTEM.GET(OptionsStart + 4, Fosc); 
  SYSTEM.GET(OptionsStart + 8, HeapStart);
  SYSTEM.GET(OptionsStart + 12, HeapLimit);
  SYSTEM.GET(OptionsStart + 16, ResourceStart);
  (* Module Initialisation Table = OptionsStart + 20 *)
  SYSTEM.GET(OptionsStart + 24, DataStart);
  SYSTEM.GET(OptionsStart + 28,  DataEnd);
  SYSTEM.GET(OptionsStart + 32, CodeStart);
  (* Check that LinkOptions is the first module loaded 
     i.e. last in the import list of Main *)
  ASSERT(cs = CodeStart);
  SYSTEM.GET(OptionsStart + 36, CodeEnd);
  SYSTEM.GET(CodeStart, StackStart);
END LinkOptions.
